package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionPWAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionPWAff extends JNIObject implements IISLStandardMethods {
	
	/* @generated */
	protected ISLUnionPWAff(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionPWAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionPWAff build(long ptr) {
		return new ISLUnionPWAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionPWAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLUnionPWAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_read_from_str) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLUnionPWAff buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_empty) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_val_on_domain 
	 * 
	@take domain v
	 * @generated
	**/
	 public static ISLUnionPWAff buildValOnDomain(ISLUnionSet domain, ISLVal v) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_val_on_domain) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, v);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_val_on_domain(getNativePtr(domain), getNativePtr(v)));
			} finally {
				taken(domain);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_param_on_domain_id 
	 * 
	@take domain id
	 * @generated
	**/
	 public static ISLUnionPWAff buildParamOnDomain(ISLUnionSet domain, ISLIdentifier id) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_param_on_domain_id) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, id);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_param_on_domain_id(getNativePtr(domain), getNativePtr(id)));
			} finally {
				taken(domain);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_aff_on_domain 
	 * 
	@take domain aff
	 * @generated
	**/
	 public static ISLUnionPWAff buildAffOnDomain(ISLUnionSet domain, ISLAff aff) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_aff_on_domain) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, aff);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_aff_on_domain(getNativePtr(domain), getNativePtr(aff)));
			} finally {
				taken(domain);
				taken(aff);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_pw_aff_on_domain 
	 * 
	@take domain pa
	 * @generated
	**/
	 public static ISLUnionPWAff buildPWAffOnDomain(ISLUnionSet domain, ISLPWAff pa) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_pw_aff_on_domain) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, pa);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_pw_aff_on_domain(getNativePtr(domain), getNativePtr(pa)));
			} finally {
				taken(domain);
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionPWAff upa, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_to_string(getNativePtr(upa), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_map_from_union_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap toUnionMap() {
		/*** PROTECTED REGION ID(isl_union_map_from_union_pw_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_union_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_from_union_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff toUnionPWMultiAff() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_from_union_pw_aff) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_from_union_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_from_union_pw_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff toMultiUnionPWAff() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_from_union_pw_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_from_union_pw_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_pw_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_union_pw_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_copy 
	 * 
	 * @generated
	**/
	public ISLUnionPWAff copy() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_copy) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_pw_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_n_pw_aff 
	 * 
	 * @generated
	**/
	public int getNbPWAffs() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_n_pw_aff) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_n_pw_aff(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_set_dim_name) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_find_dim_by_name 
	 * 
	 * @generated
	**/
	public int findDimByName(ISLDimType type, String name) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_find_dim_by_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_find_dim_by_name(getNativePtr(this), type.getValue(), name);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_reset_user 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff resetUser() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_reset_user) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_reset_user(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_extract_pw_aff 
	 * 
	 * @take space
	 * @generated
	**/
	public ISLPWAff extractPWAff(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_extract_pw_aff) DISABLED START ***/
		ISLPWAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLPWAff.build(ISLNative.isl_union_pw_aff_extract_pw_aff(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_get_pw_aff_list 
	 * 
	 * @generated
	**/
	public ISLPWAffList getPWAffList() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_get_pw_aff_list) DISABLED START ***/
		ISLPWAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWAffList.build(ISLNative.isl_union_pw_aff_get_pw_aff_list(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff neg() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_neg) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_floor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff floor() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_floor) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_floor(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_add_pw_aff 
	 * 
	 * @take this pa
	 * @generated
	**/
	public ISLUnionPWAff add(ISLPWAff pa) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_add_pw_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pa);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_add_pw_aff(getNativePtr(this), getNativePtr(pa)));
			} finally {
				taken(this);
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_add 
	 * 
	 * @take this upa2
	 * @generated
	**/
	public ISLUnionPWAff add(ISLUnionPWAff upa2) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_add) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upa2);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_add(getNativePtr(this), getNativePtr(upa2)));
			} finally {
				taken(this);
				taken(upa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_sub 
	 * 
	 * @take this upa2
	 * @generated
	**/
	public ISLUnionPWAff sub(ISLUnionPWAff upa2) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_sub) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upa2);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_sub(getNativePtr(this), getNativePtr(upa2)));
			} finally {
				taken(this);
				taken(upa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_union_add 
	 * 
	 * @take this upa2
	 * @generated
	**/
	public ISLUnionPWAff unionAdd(ISLUnionPWAff upa2) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_union_add) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upa2);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_union_add(getNativePtr(this), getNativePtr(upa2)));
			} finally {
				taken(this);
				taken(upa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_mod_val 
	 * 
	 * @take this f
	 * @generated
	**/
	public ISLUnionPWAff mod(ISLVal f) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_mod_val) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, f);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_mod_val(getNativePtr(this), getNativePtr(f)));
			} finally {
				taken(this);
				taken(f);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_scale_val 
	 * 
	 * @take this f
	 * @generated
	**/
	public ISLUnionPWAff scale(ISLVal f) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_scale_val) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, f);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_scale_val(getNativePtr(this), getNativePtr(f)));
			} finally {
				taken(this);
				taken(f);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_scale_down_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLUnionPWAff scaleDown(ISLVal v) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_scale_down_val) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_scale_down_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_involves_nan 
	 * 
	 * @generated
	**/
	public boolean involvesNaN() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_involves_nan) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_involves_nan(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLUnionPWAff upa2) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_plain_is_equal(getNativePtr(this), getNativePtr(upa2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet domain() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_pw_aff_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_zero_union_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet zeroUnionSet() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_zero_union_set) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_pw_aff_zero_union_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff coalesce() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_coalesce) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLUnionPWAff alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_align_params) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_drop_dims) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_min_val 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal minVal() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_min_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_union_pw_aff_min_val(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_max_val 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal maxVal() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_max_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_union_pw_aff_max_val(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_intersect_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWAff intersectDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_intersect_domain) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_intersect_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionPWAff intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_intersect_params) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_intersect_domain_wrapped_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWAff intersectDomainWrappedDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_intersect_domain_wrapped_domain) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_intersect_domain_wrapped_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_intersect_domain_wrapped_range 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWAff intersectDomainWrappedRange(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_intersect_domain_wrapped_range) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_intersect_domain_wrapped_range(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_subtract_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWAff subtractDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_subtract_domain) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_subtract_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_pullback_union_pw_multi_aff 
	 * 
	 * @take this upma
	 * @generated
	**/
	public ISLUnionPWAff pullback(ISLUnionPWMultiAff upma) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_pullback_union_pw_multi_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_pullback_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma)));
			} finally {
				taken(this);
				taken(upma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWAff gist(ISLUnionSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_gist) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWAff gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_gist_params) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_aff_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionPWAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
